/*----------------------------------------------------------
: http://forum.mql4.com/ru/65127/page2#993092

     -.

           :

1.        input  extern.      .

2. init   OnInit (  -  ).

3. deinit   OnDeInit (  -  ).

4. start   OnCalculated.  /  :
return(rates_total); // for ChangeInput:      OnCalculate

5.      IndicatorCounted(),     MyIndicatorCounted().
      OnCalculate :
MyIndicatorCounted(prev_calculated); // for ChangeInput:      OnCalculate, 

6.      :
// for ChangeInput:    
#include <ChangeInput.mqh>

void OnChartEvent( const int id, const long& lparam, const double& dparam, const string& sparam )
{
  EVENTBASE::MyEvent(id, lparam, dparam, sparam); // for ChangeInput:  OnChartEvent   

  return;
}

void CHANGEINPUT::MyInit( void )
{
// extern int InputParameter1 = ...    // InputParameter1_Comment
// extern double InputParameter2 = ... // InputParameter1_Comment
// extern ....

  SetGetParameter("InputParameter1_Comment", InputParameter1);
  SetGetParameter("InputParameter2_Comment", InputParameter2);
//  ....
//        -      extern

  return;
}

7.  Comment   -       .
   .

//----------------------------------------------------------

 :
 -  TAB -    (. -  ).
 -   NumLock- -   .

    - void InitSteps( void )

//---    -   .---------------*/

//      
class EVENTBASE
{
private:
  static EVENTBASE* AllEventClasses[];

  static int GetAllEventClassesSize( const EVENTBASE &This )
  {
    const int Size = ArraySize(AllEventClasses); // : unresolved static variable 'EVENTBASE::AllEventClasses'.
    int Pos = 0;

    for (int i = 0; i < Size; i++)
    {
      AllEventClasses[Pos] = AllEventClasses[i];

      if ((CheckPointer(AllEventClasses[i]) != POINTER_INVALID) && (AllEventClasses[i] != GetPointer(This)))
        Pos++;
    }

    return(Pos);
  }

public:
  EVENTBASE( bool Add = TRUE )
  {
    if (Add)
    {
      const int Pos = GetAllEventClassesSize(this);

      ArrayResize(AllEventClasses, Pos + 1);

      AllEventClasses[Pos] = GetPointer(this);
    }
  }

  ~EVENTBASE( void )
  {
    ArrayResize(AllEventClasses, GetAllEventClassesSize(this));
  }

// -  (       )
// ,  TakeProfit - .     - .  ..
//          OnChartEvent
  virtual void Event( const int id, const long &lparam, const double &dparam, const string &sparam )
  {
    return;
  }

//     
  static void MyEvent( const int id, const long &lparam, const double &dparam, const string &sparam )
  {
    const int Size = ArraySize(AllEventClasses);

    for (int i = 0; i < Size; i++)
      if (CheckPointer(AllEventClasses[i]) != POINTER_INVALID)
        AllEventClasses[i].Event(id, lparam, dparam, sparam);

    return;
  }
};

EVENTBASE* EVENTBASE::AllEventClasses[];

#define DEFAULT_DIGITS 3

class CHANGEINPUT: EVENTBASE
{
private:
  struct PARAMETER
  {
    string Name;

    double Value;
    double DefaultValue;
  };

  struct STEP
  {
    double Value;

    int IncKey;
    int DecKey;
  };

  static PARAMETER Parameter[];
  static int AmountParameters;

  static int CurrentPos;

  static STEP Step[];
  static int AmountSteps;

  static int ChangeKey;
  static int DefaultKey;

  template <typename T>
  static void IncAmount( int &Amount, T &Array[] )
  {
    Amount++;

    ArrayResize(Array, Amount);

    return;
  }

  static int FullOnCalculate( void )
  {
    long volume[];
    int spread[];

    ArraySetAsSeries(volume, TRUE);
    ArraySetAsSeries(spread, TRUE);

    const int Size = MathMin(CopyTickVolume(Symbol(), Period(), 0, Bars, volume),
                             CopySpread(Symbol(), Period(), 0, Bars, spread));

    return(OnCalculate(Size, 0, Time, Open, High, Low, Close, Volume, volume, spread));
  }

  static string StepsToString( const int digits = DEFAULT_DIGITS )
  {
    string Str = "[ ";

    for (int i = 0; i < AmountSteps; i++)
      Str = Str + "" + DoubleToStr(Step[i].Value, digits) + " ";

    Str = Str + "]";

    return(Str);
  }

  static int Restart( void )
  {
    OnDeinit(REASON_PARAMETERS);

    MyInit();
    OnInit();

    return(FullOnCalculate());
  }

  static bool MyComment( const string Str )
  {
    Comment(Str);

    return(TRUE);
  }

  static string GetMyClassName( void )
  {
    return(StringSubstr(__FUNCTION__, 0, StringFind(__FUNCTION__, "::")));
  }

  static bool EqualStep( double Value )
  {
    bool Res = FALSE;
    int i = 0;

    while ((i < AmountSteps) && !Res)
    {
      Res = (Step[i].Value == Value);

      i++;
    }

    return(Res);
  }

public:
  CHANGEINPUT( const int iChangeKey, const int iDefaultKey, bool AddEvent = TRUE ) : EVENTBASE(AddEvent)
  {
    ChangeKey = iChangeKey;
    DefaultKey = iDefaultKey;

    MyInit();

    MyComment(ParametersToString());
  }

  ~CHANGEINPUT( void )
  {
    MyComment("");
  }

  static void MyInit( void );

  static void AddStep( const double Value, const int IncKey, const int DecKey )
  {
    IncAmount(AmountSteps, Step);

    Step[AmountSteps - 1].Value = Value;
    Step[AmountSteps - 1].IncKey = IncKey;
    Step[AmountSteps - 1].DecKey = DecKey;

    return;
  }

  static string ParametersToString( const int digits = DEFAULT_DIGITS )
  {
    string Str = GetMyClassName();

    for (int i = 0; i < AmountParameters; i++)
    {
      Str = Str + "\n" + Parameter[i].Name + " = " + DoubleToStr(Parameter[i].Value, digits);

      if (i == CurrentPos)
        Str = Str + " " + StepsToString(digits);
    }

    return(Str);
  }

  template <typename T>
  static void SetGetParameter( const string Name, T &Param )
  {
    int i;

    for (i = 0; i < AmountParameters; i++)
      if (Parameter[i].Name == Name)
      {
        if (typename(T) == "bool")
          if ((Parameter[i].Value != FALSE) && ((Parameter[i].Value != TRUE)))
            Parameter[i].Value = EqualStep(Parameter[i].Value) || EqualStep(-Parameter[i].Value);

        Param = (T)Parameter[i].Value;

        break;
      }

    if (i == AmountParameters)
    {
      CurrentPos = AmountParameters;

      IncAmount(AmountParameters, Parameter);

      Parameter[CurrentPos].Name = Name;
      Parameter[CurrentPos].Value = Param;
      Parameter[CurrentPos].DefaultValue = Param;
    }

    return;
  }

  virtual void Event( const int id, const long &lparam, const double &dparam, const string &sparam )
  {
    bool FlagChange = FALSE;

    if ((AmountParameters > 0) && (id == CHARTEVENT_KEYDOWN))
    {
      if (lparam == DefaultKey)
      {
        FlagChange = (Parameter[CurrentPos].Value != Parameter[CurrentPos].DefaultValue);

        if (FlagChange)
          Parameter[CurrentPos].Value = Parameter[CurrentPos].DefaultValue;
      }
      else if (lparam == ChangeKey)
      {
        CurrentPos++;

        if (CurrentPos == AmountParameters)
          CurrentPos = 0;

        if (AmountParameters > 1)
          MyComment(ParametersToString());
      }
      else
        for (int i = 0; i < AmountSteps; i++)
          if (lparam == Step[i].IncKey)
          {
            FlagChange = TRUE;

            Parameter[CurrentPos].Value += Step[i].Value * dparam;

            break;
          }
          else if (lparam == Step[i].DecKey)
          {
            FlagChange = TRUE;

            Parameter[CurrentPos].Value -= Step[i].Value * dparam;

            break;
          }

      if (FlagChange)
      {
        Restart();

        MyComment(ParametersToString());
      }
    }

    return;
  }
};

PARAMETER CHANGEINPUT::Parameter[];
int CHANGEINPUT::AmountParameters = 0;

int CHANGEINPUT::CurrentPos;

STEP CHANGEINPUT::Step[];
int CHANGEINPUT::AmountSteps = 0;

int CHANGEINPUT::ChangeKey;
int CHANGEINPUT::DefaultKey;


#define KEY_TAB 9
#define KEY_NUMLOCK5 101

#define KEY_NUMLOCK1 97
#define KEY_NUMLOCK2 98
#define KEY_NUMLOCK3 99

#define KEY_NUMLOCK7 103
#define KEY_NUMLOCK8 104
#define KEY_NUMLOCK9 105

class CHANGEINPUT_STEP : public CHANGEINPUT
{
private:
  void InitSteps( void ) const
  {
    CHANGEINPUT::AddStep(0.1, KEY_NUMLOCK7, KEY_NUMLOCK1);
    CHANGEINPUT::AddStep(1, KEY_NUMLOCK8, KEY_NUMLOCK2);
    CHANGEINPUT::AddStep(10, KEY_NUMLOCK9, KEY_NUMLOCK3);

    return;
  }

public:
  CHANGEINPUT_STEP( const int iChangeKey, const int iDefaultKey, bool AddEvent = TRUE ) : CHANGEINPUT(iChangeKey, iDefaultKey, AddEvent)
  {
    InitSteps();
  }
};

//      InitSteps  OnInit()    .
CHANGEINPUT_STEP ChangeInput(KEY_TAB, KEY_NUMLOCK5);

int MyIndicatorCounted( const int Value = -1 )
{
  static int PrevCalculated = 0;

  if (Value >= 0)
    PrevCalculated = MathMax(Value - 1, 0);

  return(PrevCalculated);
}